<?php
///===================================================================================
///                                                Fichier : refreshLoginOpener.php
///===================================================================================
///
/// Se dconnecter ventuellement de Spip,
/// puis rafraichir la fentre ayant activ le login.
///
/// Activation
///    Via le formulaire d'identification Spip (cf. squelette "login")
///
/// Paramtres
///    $newOpenerUrl      Url de redirection de l'appelant (au lieu d'un rafraichissement)
///    $logoutFromSpip    Login de l'utilisateur
///                       Si non vide : dconnexion puis rafraichissement de l'appelant
///    $logoutOK          Renseign  1 si la dconnexion a t effectue
///                       => rafraichissement de l'appelant
///
///===================================================================================
///
/// Quitter l'espace "Abonns"

    if($logoutFromSpip && !$logoutOK) {

      $logout = $logoutFromSpip;
      $url    = "$PHP_SELF?logoutOK=1&newOpenerUrl=$newOpenerUrl"; // Pour le retour...

      include 'spip_cookie.php3';       // Au retour : rechargement de la page avec $logoutOK=1

    }

//------------------------------------------------------------------------------------
?>
<HTML>
  <HEAD>
    <META HTTP-EQUIV="Content-Type"  CONTENT="text/html; CHARSET=iso-8859-1">
    <META HTTP-EQUIV="expires"       CONTENT="0">
    <META HTTP-EQUIV="Cache-Control" CONTENT="no-store, no-cache, must-revalidate">
    <META HTTP-EQUIV="Pragma"        CONTENT="no-cache">
    <META HTTP-EQUIV="Last-Modified" CONTENT=".gmdate('D, d M Y H:i:s')." GMT">

    <SCRIPT>

//--------------------------------------------------------------------------------------------
///    function cleanAddUrl(url,par)
    function cleanAddUrl(url,par) {

      var u,clean,sep,p,param;
        p = par.split('=');
        param = p[0];

        u = url.split('?');
        clean = u[0];
        url   = u[1];
        sep = '?';

        if(url) {
          urls = url.split('&');        // urls[] = "p=v"
          for (iUrl in urls) {
            p = urls[iUrl].split('=');
            if(p[0]!=param) {
              clean += sep+urls[iUrl];  // on garde ce paramtre
              sep = '&';
            }
          }
        }
        return clean+sep+par;
    }
//
//--------------------------------------------------------------------------------------------
///    function addToSelf(objet,params)
    function addToSelf(objet,params) {

      var objet,url,i,param;
        url = objet.document.location.href; // Page appelante

        for (i=0; i<params.length; i++) url = cleanAddUrl(url,params[i]);

        return url;
    }

//--------------------------------------------------------------------------------------------
///    function callSelf(objet,param)
    function callSelf(objet,param) {

          objet.document.location.href = param;
    }

//--------------------------------------------------------------------------------------------
///    function addCallSelf(objet,params)
    function addCallSelf(objet,params) {

        callSelf(objet, addToSelf(objet,params));
    }

//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------
///    function refreshLoginOpener(newUrlOpener)
    function refreshLoginOpener(newUrlOpener) {
//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------

      if(window.name=="loginSpip") {

//--------------------------------------------------------------------------------------------
// Cas o la fentre courante est un popup : rafraichissement de l'appelant
// Sinon : redirection vers l'espace priv de Spip

        if(opener && opener.window) {

//    Rcuprer la redirection ventuelle vers une page spcifique
          if(newUrlOpener) {
            urlRet=newUrlOpener;

          } else {

//   Sinon : Rcuprer l'adresse courante de l'appelant
            urlRet=opener.window.document.location.href;

//         : Lui retirer le paramtre ventuel "logoutFromSpip=1"
            logout='logoutFromSpip=1';
            iUrl=urlRet.indexOf(logout);
            if(iUrl>0)  // Garder le symbole '?' ou '&' prcdant 'logoutFromSpip=1'
              urlRet=urlRet.substring(0,iUrl)+urlRet.substring(iUrl+logout.length+1,urlRet.length);

//         : Lui retirer le '#' ventuel
            iUrl=urlRet.indexOf('#');
            if(iUrl>0)
              urlRet=urlRet.substring(0,iUrl);

          } // Fin if(newUrlOpener)... else...

//   Lui ajouter ventuellement le paramtre "recalcul=oui"
          if(urlRet.indexOf('recalcul=oui')<0) {
            if(urlRet.indexOf('?')>0) { urlRet += '&'; }
            else                      { urlRet += '?'; }
            urlRet += 'recalcul=oui';
          }

//   Rafraichir la fentre appelante
          opener.window.document.location.href=urlRet;
          opener.window.focus();
<?
          if(!$logoutOK && !$newOpenerUrl) {
?>          window.document.location.href='login.php3';
<?        } else {
?>          window.close();
<?        }
?>
        } // Fin if(opener && opener.window)

//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------
// Cas o la fentre courante n'est pas un popup :
//    Redirection vers l'espace priv"

      } else { // Suite if(window.name=="loginSpip")

        document.location.href="ecrire/";

      } // Fin if(window.name=="loginSpip")... else...

    } // Fin function refreshLoginOpener(newUrlOpener)

//--------------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------------

      refreshLoginOpener("<?=$newOpenerUrl?>");

    </SCRIPT>
  </HEAD>
</HTML>
